(function(window, App, $) {
	'use strict';

	function HomePageClickableWidget(input) {
		this.widget = input.widget;
		this.$container = input.element.find('.widget-inner');
		this.template = App.templates.getTemplate(this.defaults.template);
		this.options = $.extend({}, this.defaults, input.options);
		
		this.$widgetContent = input.element.find('.widget-content');
		if (this.$widgetContent.length === 0) {
			this.$container = input.element.find('.widget-inner');
			this.$header = input.element.find('header');
		} else {
			this.$container = this.$widgetContent.find('.widget-inner');
			this.$header = this.$widgetContent.find('header');
		}
		this._render();
		this.widget.loader.stop();
	}

	HomePageClickableWidget.prototype = {
		defaults : {
			background: 'white',
			color: 'black',
			template : 'helium/custom/launchpad/templates/widget/homePageClickable'
		},

		_render : function() {
			this.$container.empty().append(this.template(this.options));
			this.$container.on('click', () => {
				var args = {options: {config:this.options.onclickparams}};
				App.Utils.execFunction(this.options.onclick, window, this,args);
			});
			this.$container.css('cursor', 'pointer');
			this.$widgetContent.find('.pusher, header, .headericon > i').css({
				background: this.options.background,
				color: this.options.color
			});
		},
		
	};

	var createHomePageClickableWidget = function(input) {
		return new HomePageClickableWidget(input);
	};

	App.launchpad = App.launchpad || {};
	App.launchpad.initHomePageClickableWidget = createHomePageClickableWidget;
})(window, window.App || {}, jQuery);