if (!window.launchpad) {
    window.launchpad = {};
}
if (!window.launchpad.setpayload) {
    window.launchpad.setpayload = {};
}

App.dataTable.InvokeServiceForm.prototype.successCallback = function (response) {
    try {
        App.log.debug(response);
        this.form.modal.close();
        this.dataTable.widget.refreshWidgetAndToolbar();

        Object.keys(response).forEach(key => {
            if (key === 'results') {
                if (response.results.length === 0) {
                    App.toaster.warning("The object has not been changed ");
                } else {
                    if (Object.keys(response.results[0]).indexOf('errors') !== -1) {
                        let errorTitle = "";
                        if (response.results[0].errors.at(0).key !== null && response.results[0].errors.at(0).key !== undefined) {
                            errorTitle = response.results[0].errors.at(0).key;
                        }
                        let errorMessage = "";
                        if (response.results[0].errors.at(0).message !== null && response.results[0].errors.at(0).message !== undefined) {
                            errorMessage = response.results[0].errors.at(0).message;
                        }
                        App.toaster.error(errorMessage, errorTitle, { showDuration: 10000, timeOut: 1000 });
                    } else {
                        App.toaster.success(App.i18n.t(this.inputParams.form.successMessage), { showDuration: 10000, timeOut: 1000 });
                    }
                }
            }

            if (key === 'result') {
                if (response.result.length > 0) {
                    if (response.result[0].errors !== null && response.result[0].errors !== undefined && response.result[0].errors.length > 0) {
                        let errorTitle = "";
                        if (response.result[0].errors.at(0).errorTitle !== null && response.result[0].errors.at(0).errorTitle !== undefined) {
                            errorTitle = response.result[0].errors.at(0).errorTitle;
                        }
                        let errorMessage = "";
                        if (response.result[0].errors.at(0).errorMessage !== null && response.result[0].errors.at(0).errorMessages !== undefined) {
                            errorMessage = response.result[0].errors.at(0).errorMessages;
                        }
                        let errorCode = "";
                        if (response.result[0].errors.at(0).errorCode !== null && response.result[0].errors.at(0).errorCode !== undefined) {
                            errorCode = ` error code: ${response.result[0].errors.at(0).errorCode}`;
                        }
                        App.toaster.error(errorMessage + errorCode, errorTitle, { showDuration: 10000, timeOut: 1000 });
                    }
                }
            }

            if (key === 'parsedResult') {
                if (response.parsedResult.length > 0) {
                    let responseObject = JSON.parse(response.parsedResult);
                    let objectName = "";
                    if (responseObject.rawAttr) {
                        if (JSON.parse(responseObject.rawAttr).length > 0) {
                            const responseObjectAttributes = JSON.parse(responseObject.rawAttr)[0].attributes;
                            for (let i = 0; i < responseObjectAttributes.length; i++) {
                                if (responseObjectAttributes[i].name.includes('label')) {
                                    objectName = responseObjectAttributes[i].value;
                                    break;
                                }
                            }
                        }
                    }
                    App.toaster.success({
                        title: App.i18n.t(this.inputParams.form.successMessage),
                        message: `Object ${objectName}`,
                        showDuration: 2000
                    });
                }
            }
        });
    } catch (error) {
        App.log.error({ title: `launchpad.setpayload.successCallback`, message: error }, {}, error);
    }
}

launchpad.setpayload = {
    setReservePayloadAfterForm: function (formInput, formData) {
        try {
            let choice = formInput[2].reserveField.values[0].value;

            let userSelectedRef = false;
            let userSelectedInstances = false;
            let isIdInserted = -1;

            //OOTB reference ===> UPS : model/bus/.... OOTB instance ===> relationship : model/rel/...
            switch (choice) {
                case "INSTANCE":
                    userSelectedRef = false;
                    userSelectedInstances = true;
                    break;
                case "REF":
                    userSelectedRef = true;
                    userSelectedInstances = false;
                    break;
                case "REF|INSTANCE":
                    userSelectedRef = true;
                    userSelectedInstances = true;
                    break;
                default:
                    userSelectedRef = false;
                    userSelectedInstances = false;
            }

            let data = formData.dataTable.selectedRows();

            for (let iCounter = 0; iCounter < data.length; iCounter++) {
                if (userSelectedInstances) {
                    if (formData.dataTable.metadataMapping[data[iCounter].id].relationshipId != null) {
                        formData.inputParams.form.body.urls.push(`model/rel/${formData.dataTable.metadataMapping[data[iCounter].id].relationshipId}`);
                    }
                }
                if (userSelectedRef) {
                    isIdInserted = formData.inputParams.form.body.urls.toString().search(formData.dataTable.metadataMapping[data[iCounter].id].objectId);
                    if (isIdInserted === -1) {
                        formData.inputParams.form.body.urls.push(`model/bus/${formData.dataTable.metadataMapping[data[iCounter].id].objectId}`);
                    }
                }
            }
        } catch (error) {
            App.log.error({ title: `setReservePayloadAfterForm`, message: error }, {}, error);
        }
    },

    setDetachPayload: function (payload, response, resolve, reject) {
        try {
            if (this.widget.selectedRowIdToObjectsId != null) {

                let allReferenceIdsBody = [];
                let indexForData = 1;
                if (response[indexForData] === null || typeof response[indexForData] === "undefined") {
                    indexForData = 3;
                }

                if (response[indexForData] === null || typeof response[indexForData] === "undefined") {
                    App.toaster.warning("In the given context, the object has no parent. The object will not be disconnected.");
                    reject(response);
                    return;
                }

                const allReferencePhysicalIds = response[indexForData].split('\x07');
                const allReferenceIds = response[(indexForData + 1)].split('\x07');


                Object.keys(this.widget.selectedRowIdToObjectsId).forEach(key => {
                    if (this.dataTable.metadataMapping[key] !== null && this.dataTable.metadataMapping[key] !== undefined) {
                        let relId = this.dataTable.metadataMapping[key].relationshipId;
                        if (relId != null) {  //Object is parent
                            let index = allReferencePhysicalIds.indexOf(relId);
                            if (index !== -1) {
                                allReferenceIdsBody.push(allReferenceIds[index]);
                            }
                        } else {
                            App.toaster.warning("In the given context, the object has no parent. The object will not be disconnected.");
                            reject(response);
                        }
                    }
                });
                if (allReferenceIdsBody.length > 0) {
                    const newPayloadData = {
                        version: '1.0',
                        bAllOrNothing: false,
                        instances: allReferenceIdsBody
                    };

                    payload = {
                        method: payload.method,
                        url: payload.url,
                        data: JSON.stringify(newPayloadData),
                        headers: payload.headers
                    };
                    resolve(payload);
                }

            } else {
                App.toaster.warning("Incorrect data. The object will not be disconnected.");
                reject(response);
            }
        } catch (error) {
            App.log.error({ title: `setDetachPayload`, message: error }, {}, error);
        }
    },

    setPayloadAddTimestamp: function (payload, response, resolve, reject) {
        try {
            let currTimestamp = new Date().getTime();
            let newUrl = `${payload.url}timestamp${currTimestamp}=${currTimestamp}&`;
            payload = {
                method: payload.method,
                url: newUrl,
                headers: payload.headers
            };
            resolve(payload);
        } catch (error) {
            App.log.error({ title: `setPayloadAddTimestamp`, message: error }, {}, error);
        }
    },

    setPayloadAddParentOrigin: function (payload, response, resolve, reject) {
        try {
            let newParentOrigin = "";
            if (response.length > 0) {
                response.forEach(element => {
                    if (element.at(2) === "") {
                        newParentOrigin += `parentOrigin=V6&`;
                    } else {
                        newParentOrigin += `parentOrigin=${element.at(2)}&`;
                    }
                });
            }

            let currTimestamp = new Date().getTime();
            let newUrl = `${payload.url}${newParentOrigin}timestamp${currTimestamp}=${currTimestamp}&`;
            payload = {
                method: payload.method,
                url: newUrl,
                headers: payload.headers
            };
            resolve(payload);
        } catch (error) {
            App.log.error({ title: `setPayloadAddParentOrigin`, message: error }, {}, error);
        }
    },

    setCreateObjectPayloadAfterForm: function (formInput, formData) {
        try {
            const newPayload = {
                attributes: formData.preResponse.result[0].attributes,
                interfaces: formData.preResponse.result[0].interfaces,
                type: formData.preResponse.result[0].type
            };

            let isCatiaTemplate = false;
            let formKeys = Object.keys(formInput[2]);

            //Template
            if (formKeys.includes("Template") && formInput[2].Template.values[0].value !== null && formInput[2].Template.values[0].value !== "") {
                newPayload.attributes.volatileAttributes[0].value = formInput[2].Template.values[0].value;
                isCatiaTemplate = formInput[2].Template.values[0].value.includes("UPSV5");
            }
            Object.assign(newPayload.attributes.volatileAttributes[0], { "modified": true });

            //V_Name 
            if (formKeys.includes("V_name") && formInput[2].V_name.values[0].value !== null && formInput[2].V_name.values[0].value !== "") {
                newPayload.attributes.publicAttributes[0].value = formInput[2].V_name.values[0].value;
                if (isCatiaTemplate) {
                    newPayload.attributes.volatileAttributes[1].value = formInput[2].V_name.values[0].value;
                }
            }

            //V_description
            if (formKeys.includes("V_description") && formInput[2].V_description.values[0].value !== null && formInput[2].V_description.values[0].value !== "") {
                newPayload.attributes.publicAttributes[2].value = formInput[2].V_description.values[0].value
                Object.assign(newPayload.attributes.publicAttributes[2], { "modified": true });
            }

            formData.inputParams.form.body.create.push(newPayload);

            if (formInput[0].includes("Part.xml")) {
                const DShapeArray = {
                    type: formData.preResponse.result[1].type,
                    interfaces: formData.preResponse.result[1].interfaces,
                    attributes: formData.preResponse.result[1].attributes
                };

                formData.inputParams.form.body.create.push(DShapeArray);
            }
        } catch (error) {
            App.log.error({ title: `setCreateObjectPayloadAfterForm`, message: error }, {}, error);
        }
    },

    setCreateConnectObjectPayloadAfterForm: function (formInput, formData) {
        try {
            const selectedPhysicalIds = Object.create(formData.inputParams.body.split(":")[1].split(","));

            if (selectedPhysicalIds.length > 0) {
                let oldUrl = formData.inputParams.form.url;
                let newURL = oldUrl.slice(0, oldUrl.indexOf("&parsed="));
                selectedPhysicalIds.forEach(id => {
                    newURL += `&aggregating_context=${id.replaceAll(/\W/g, '')}`;
                });
                newURL += oldUrl.slice(oldUrl.indexOf("&parsed="));
                formData.inputParams.form.url = newURL;
            }
            launchpad.setpayload.setCreateObjectPayloadAfterForm(formInput, formData);

        } catch (error) {
            App.log.error({ title: `setCreateConnectObjectPayloadAfterForm`, message: error }, {}, error);
        }
    }


};